• leetcode 788. Rotated Digits


    X is a good number if after rotating each digit individually by 180 degrees, we get a valid number that is different from X.  Each digit must be rotated - we cannot choose to leave it alone.

    A number is valid if each digit remains a digit after rotation. 0, 1, and 8 rotate to themselves; 2 and 5 rotate to each other; 6 and 9 rotate to each other, and the rest of the numbers do not rotate to any other number and become invalid.

    Now given a positive number N, how many numbers X from 1 to N are good?

    Example:
    Input: 10
    Output: 4
    Explanation: 
    There are four good numbers in the range [1, 10] : 2, 5, 6, 9.
    Note that 1 and 10 are not good numbers, since they remain unchanged after rotating.

    fuck!没有看懂题目!!!听说是 一个数 valid 的条件是这个数不包含 3, 4, 7 且包含至少一个 2, 5, 6, 9
    最直观的解法:
    class Solution(object):
        def rotatedDigits(self, N):
            """
            :type N: int
            :rtype: int
            """
            # 一个数 valid 的条件是这个数不包含 3, 4, 7 且包含至少一个 2, 5, 6, 9                        
            def is_valid(n):        
                found = False
                while n:
                    d = n % 10
                    if d in {3,4,7}:
                        return False
                    if d in {2,5,6,9}:
                        found = True
                    n /= 10
                return found
            
            ans = 0
            for n in range(1, N+1):
                if is_valid(n):
                    ans += 1
            return ans

    看还有dp解法的:

    Using a int[] for dp.
    dp[i] = 0, invalid number
    dp[i] = 1, valid and same number
    dp[i] = 2, valid and different number

        public int rotatedDigits(int N) {
            int[] dp = new int[N + 1];
            int count = 0;
            for(int i = 0; i <= N; i++){
                if(i < 10){
                    if(i == 0 || i == 1 || i == 8) dp[i] = 1;
                    else if(i == 2 || i == 5 || i == 6 || i == 9){
                        dp[i] = 2;
                        count++;
                    }
                } else {
                    int a = dp[i / 10], b = dp[i % 10];
                    if(a == 1 && b == 1) dp[i] = 1;
                    else if(a >= 1 && b >= 1){
                        dp[i] = 2;
                        count++;
                    }
                }
            }
            return count;
        }
    

     最直观的解法:

    class Solution(object):
        def rotatedDigits(self, N):
            counts = 0
            for num in range(1, N+1):
                number = str(num)
                if '3' in number or '7' in number or '4' in number: # This will be an invalid number upon rotation
                    continue # Skip this number and go to next iteration
                if '2' in number or '5' in number or '6' in number or '9' in number:
                    counts += 1
            return counts
  • 相关阅读:
    实时信号阻塞队列大小测试
    实时信号和非实时信号
    [Linux]关于sigprocmask函数的讨论
    java中Map集合的常用方法 (转)
    佛跳墙
    百万数据查询效率提高方法(转)
    bootstrap table 前后端分页(超级简单)
    bootstrap table 分页序号递增问题 (转)
    Spring boot+mybatis+thymeleaf 实现登录注册,增删改查
    js弹出对话框的三种方式(转)
  • 原文地址:https://www.cnblogs.com/bonelee/p/8593676.html
Copyright © 2020-2023  润新知